/*
times2bpm.c
given the time of every eighth beat, determine bpms

Copyright (c) 2004 Damian Yerrick

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation files
(the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software
is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS
OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#define BEATS_PER_SAMPLE 8

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

double getno(void)
{
  char buf[256];
  double rv;

  if(!fgets(buf, sizeof(buf), stdin))
    return -65535;
  if(!sscanf(buf, "%lf", &rv))
    return -65535;
  return rv;
}

int main(void)
{
  int beat = 0;
  float istart, iend;

  istart = getno();
  iend = getno();
  printf("#OFFSET:%.3f;\n#BPMS:", -istart);

  while(iend > -65535)
  {
    if(beat != 0)
      putchar(',');
    printf("%d=%.3f", beat, (60 * BEATS_PER_SAMPLE)/(iend - istart));
    beat += BEATS_PER_SAMPLE;
    istart = iend;
    iend = getno();
  }
  putchar(';');
  putchar('\n');
  return 0;
}
